import clips

def clips_piece_input():
    #get the value someway
    return clips.Integer(val)

def clips_move_input():
    #get the value someway
    return clips.Integer(val)

clips.RegisterPythonFunction(clips_piece_input, "piece-input")
clips.RegisterPythonFunction(clips_move_input, "move-input")

def LoadFunctions(clips, team):
    # Generates the CLIPS module
    mod_name = "EQUIPO-" + team
    # Module body
    mod_body  = "(import MAIN deftemplate initial-fact ficha dimension "\
                "tiempo mueve tiempo-inicial)" \
                "(import MAIN deffunction ?ALL)"
    mod_equipo = clips.BuildModule(mod_name, mod_body)

    # Function that reads the movement 
    fun_name = 'read-mov'
    fun_para = '?n ?t'
    fun_body = '(bind ?mov (python-call move-input))' \
               '(printout t "EQUIPO-B mueve a" ?n "' \
               ' hacia " ?mov " en t " ?t crlf)' \
               '(assert (mueve (num ?n) (mov ?mov) (tiempo ?t)))'

    fun_lectura_mov = mod_equipo.BuildFunction(fun_name, fun_para, fun_body)

    # rule with max salience that will be trigged on every turn
    rule_name = 'lectura' + team

    rule_prec = '(declare (salience 100))' \
                '(tiempo ?t)'

    rule_body  = '(bind ?n (python-call piece-input))' \
                 '(read-mov ?n ?t)'

    lectura = mod_equipo.BuildRule(rule_name, rule_prec, rule_body)
    
    # Rule name
    rule_name = 'termina'
    # Rule precontents
    rule_prec  = '(declare (salience 100))'\
                 '(tiempo ?t)' \
                 '(dimension ?dim)' \
                 '(mueve (num ?n) (mov ?m) (tiempo ?t))' \
                 '(ficha (equipo "A") (num ?n) (pos-x ?x) (pos-y ?y))' \
                 '(test (mov-valido ?dim ?m ?x ?y))' \
                 '(not (ficha (equipo "A")  (pos-x ?x2&:' \
                 '(= (+ ?x (mov-x ?m)) ?x2)) (pos-y ?y2&:' \
                 '(= (+ ?y (mov-y ?m)) ?y2))))'
    # =>
    # Rule body
    rule_body  = '(pop-focus)'
    # Building the rule
    termina = mod_equipo.BuildRule(rule_name, rule_prec, rule_body)
    # ---------------------------------
