def make_pairings(teams, back_round=False):
    """This functions do the pairings using round-robin algorithm.

    Keywords arguments:
    teams -- list of teams names that participate on the contest
    back_round -- Boolean value that indicates if it's a two round contest

    Returns a list that contains lists of matchs, something like that:
    [[(a,d), (b,c)], [(a,c), (d,b)], [(a,b), (c,d)] 
    """
    random.shuffle(teams)
    
    #If has an odd number of teams, we have to add a ghost team
    if len(teams) % 2 == 1:
        teams.append('aux_ghost_team')

    first_order = teams #to check if we finish pairing
    elements = teams
    matchs = []

    finish = False #flag to control if we make the entire round

    while not finish:
        matchs.append(_get_pairing(elements))
        elements = _rotate_less_first(elements)
        if elements == first_order:
            finish = True

    return matchs
